#ifndef _consumer_h_
#define _consumer_h_

//  Module: CONSUMER.H

//  All of the consumers defined in this module use their constructors
//  to connect to broadcast channels.  They use there destructors to
//  disconnect from the broadcast channels.

#include    <string.h>
#include    "ROSTER.H"
#include    "CHNNLDEF.H"

class Airport : public WindData, public AirData, public TornadoWarning
{
    char    caName[80];
public:
    Airport (const char *cpName)
                           {strcpy(caName,cpName);
                            oRoster.Connect((WindData *)this);
                            oRoster.Connect((AirData *)this);
                            oRoster.Connect((TornadoWarning *)this);
                           }
    ~Airport (void) {oRoster.Disconnect((WindData *)this);
                     oRoster.Disconnect((AirData *)this);
                     oRoster.Disconnect((TornadoWarning *)this);
                    }
    void ServeWindData (int iSpeed, int iDirection);
    int  ServeAirData (int iTemperature,
                       int iBarometricPressure,
                       int iHumidity);
    void ServeTornadoWarning (void);
};                               

class FireDepartment : public WindData, public AirData, public TornadoWarning
{
public:
    FireDepartment (void)  {oRoster.Connect((WindData *)this);
                            oRoster.Connect((AirData *)this);
                            oRoster.Connect((TornadoWarning *)this);
                           }
    ~FireDepartment (void) {oRoster.Disconnect((WindData *)this);
                     oRoster.Disconnect((AirData *)this);
                     oRoster.Disconnect((TornadoWarning *)this);
                    }
    void ServeWindData (int iSpeed, int iDirection);
    int  ServeAirData (int iTemperature,
                       int iBarometricPressure,
                       int iHumidity);
    void ServeTornadoWarning (void);
};                               

class School : public TornadoWarning
{
public:
    School (void) {oRoster.Connect((TornadoWarning *)this);}
    ~School (void) {oRoster.Disconnect((TornadoWarning *)this);}
    void ServeTornadoWarning (void);
};

#endif
